Index: /trunk/LMDZ.PLUTO/libf/phypluto/condense_n2.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/condense_n2.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/condense_n2.F90	(revision 3195)
@@ -1,3 +1,3 @@
-subroutine condens_n2(klon,nlayer,nq,ptimestep, &
+subroutine condense_n2(klon,klev,nq,ptimestep, &
       pcapcal,pplay,pplev,ptsrf,pt, &
       pphi,pdt,pdu,pdv,pdtsrf,pu,pv,pq,pdq, &
@@ -8,9 +8,10 @@
   use radinc_h, only : naerkind
   use comgeomfi_h
-  use comcstfi_mod, only: g, r, cpp
-  USE surfdat_h, only: phisfi
-  USE tracer_h, only: noms, igcm_n2
-  USE callkeys_mod, only: fast,ch4lag,latlag,lw_n2,nbsub,no_n2frost,tsurfmax,kmixmin,source_haze,vmrlag
-  USE dimphy, only : klon,klev
+  use comcstfi_mod, only: g, r, cpp, pi
+  USE surfdat_h, only: phisfi,kp,p00
+  USE tracer_h, only: noms, igcm_n2, lw_n2
+  USE callkeys_mod, only: fast,ch4lag,latlag,nbsub,no_n2frost,tsurfmax,kmixmin,source_haze,vmrlag
+  USE comvert_mod, ONLY: ap,bp
+  use geometry_mod, only: latitude
 
 
@@ -22,25 +23,25 @@
 !     Condense and/or sublime N2 ice on the ground and in the
 !     atmosphere, and sediment the ice.
-!  
+!
 !     Inputs
-!     ------ 
+!     ------
 !     klon                 Number of vertical columns
-!     nlayer                Number of layers
-!     pplay(klon,nlayer)   Pressure layers
-!     pplev(klon,nlayer+1) Pressure levels 
-!     pt(klon,nlayer)      Temperature (in K)
+!     klev                Number of layers
+!     pplay(klon,klev)   Pressure layers
+!     pplev(klon,klev+1) Pressure levels
+!     pt(klon,klev)      Temperature (in K)
 !     ptsrf(klon)          Surface temperature
-!     
-!     pdt(klon,nlayermx)   Time derivative before condensation/sublimation of pt
+!
+!     pdt(klon,klev)   Time derivative before condensation/sublimation of pt
 !     pdtsrf(klon)         Time derivative before condensation/sublimation of ptsrf
 !     picen2(klon)         n2 ice at the surface (kg/m2)
-!     
+!
 !     Outputs
 !     -------
 !     pdpsrf(klon)         \  Contribution of condensation/sublimation
-!     pdtc(klon,nlayermx)  /  to the time derivatives of Ps, pt, and ptsrf
+!     pdtc(klon,klev)  /  to the time derivatives of Ps, pt, and ptsrf
 !     pdtsrfc(klon)       /
 !     pdicen2(klon)         Tendancy n2 ice at the surface (kg/m2)
-!     
+!
 !     Both
 !     ----
@@ -49,9 +50,9 @@
 !
 !     Authors
-!     ------- 
+!     -------
 !     Francois Forget (1996,2013)
 !     Converted to Fortran 90 and slightly modified by R. Wordsworth (2009)
-!     
-!     
+!
+!
 !==================================================================
 
@@ -59,22 +60,22 @@
 !     Arguments
 
-  INTEGER klon, nlayer, nq
-
-  REAL ptimestep 
-  REAL pplay(klon,nlayer),pplev(klon,nlayer+1)
+  INTEGER klon, klev, nq
+
+  REAL ptimestep
+  REAL pplay(klon,klev),pplev(klon,klev+1)
   REAL pcapcal(klon)
-  REAL pt(klon,nlayer)
+  REAL pt(klon,klev)
   REAL ptsrf(klon),flu1(klon),flu2(klon),flu3(klon)
-  REAL pphi(klon,nlayer)
-  REAL pdt(klon,nlayer),pdtsrf(klon),pdtc(klon,nlayer)
+  REAL pphi(klon,klev)
+  REAL pdt(klon,klev),pdtsrf(klon),pdtc(klon,klev)
   REAL pdtsrfc(klon),pdpsrf(klon)
   REAL picen2(klon),psolaralb(klon),pemisurf(klon)
- 
-
-  REAL pu(klon,nlayer) ,  pv(klon,nlayer)
-  REAL pdu(klon,nlayer) , pdv(klon,nlayer)
-  REAL pduc(klon,nlayer) , pdvc(klon,nlayer)
-  REAL pq(ngridmx,nlayer,nq),pdq(klon,nlayer,nq)
-  REAL pdqc(klon,nlayer,nq)
+
+
+  REAL pu(klon,klev) ,  pv(klon,klev)
+  REAL pdu(klon,klev) , pdv(klon,klev)
+  REAL pduc(klon,klev) , pdvc(klon,klev)
+  REAL pq(klon,klev,nq),pdq(klon,klev,nq)
+  REAL pdqc(klon,klev,nq)
 
 !-----------------------------------------------------------------------
@@ -83,53 +84,53 @@
   INTEGER l,ig,ilay,it,iq,ich4_gas
 
-  REAL*8 zt(ngridmx,nlayermx)
+  REAL*8 zt(klon,klev)
   REAL tcond_n2
   REAL pcond_n2
   REAL glob_average2d         ! function
-  REAL zqn2(ngridmx,nlayermx) ! N2 MMR used to compute Tcond/zqn2
-  REAL ztcond (ngridmx,nlayermx)
-  REAL ztcondsol(ngridmx),zfallheat
-  REAL pdicen2(ngridmx)
-  REAL zcondicea(ngridmx,nlayermx), zcondices(ngridmx)
-  REAL zfallice(ngridmx,nlayermx+1)
-  REAL zmflux(nlayermx+1)
-  REAL zu(nlayermx),zv(nlayermx)
-  REAL zq(nlayermx,nqmx),zq1(nlayermx)
-  REAL ztsrf(ngridmx)
-  REAL ztc(nlayermx), ztm(nlayermx+1) 
-  REAL zum(nlayermx+1) , zvm(nlayermx+1)
-  REAL zqm(nlayermx+1,nqmx),zqm1(nlayermx+1)
-  LOGICAL condsub(ngridmx)
+  REAL zqn2(klon,klev) ! N2 MMR used to compute Tcond/zqn2
+  REAL ztcond (klon,klev)
+  REAL ztcondsol(klon),zfallheat
+  REAL pdicen2(klon)
+  REAL zcondicea(klon,klev), zcondices(klon)
+  REAL zfallice(klon,klev+1)
+  REAL zmflux(klev+1)
+  REAL zu(klev),zv(klev)
+  REAL zq(klev,nq),zq1(klev)
+  REAL ztsrf(klon)
+  REAL ztc(klev), ztm(klev+1)
+  REAL zum(klev+1) , zvm(klev+1)
+  REAL zqm(klev+1,nq),zqm1(klev+1)
+  LOGICAL condsub(klon)
   REAL subptimestep
   Integer Ntime
-  real masse (nlayermx),w(nlayermx+1)
-  real wq(ngridmx,nlayermx+1)
+  real masse (klev),w(klev+1)
+  real wq(klon,klev+1)
   real vstokes,reff
   real dWtotsn2
-  real condnconsn2(ngridmx)
+  real condnconsn2(klon)
   real nconsMAXn2
 !     Special diagnostic variables
-  real tconda1(ngridmx,nlayermx)
-  real tconda2(ngridmx,nlayermx)
-  real zdtsig (ngridmx,nlayermx)
-  real zdtlatent (ngridmx,nlayermx)
-  real zdt (ngridmx,nlayermx)
-  REAL albediceF(ngridmx)
-  SAVE albediceF
+  real tconda1(klon,klev)
+  real tconda2(klon,klev)
+  real zdtsig (klon,klev)
+  real zdtlatent (klon,klev)
+  real zdt (klon,klev)
+  REAL albediceF(klon)
+!   SAVE albediceF
   INTEGER nsubtimestep,itsub    !number of subtimestep when calling vl1d
   REAL subtimestep        !ptimestep/nsubtimestep
-  REAL dtmax              
-
-  REAL zplevhist(ngridmx)
-  REAL zplevnew(ngridmx)
-  REAL zplev(ngridmx)
-  REAL zpicen2(ngridmx)
-  REAL ztsrfhist(ngridmx)
-  REAL zdtsrf(ngridmx)
+  REAL dtmax
+
+  REAL zplevhist(klon)
+  REAL zplevnew(klon)
+  REAL zplev(klon)
+  REAL zpicen2(klon)
+  REAL ztsrfhist(klon)
+  REAL zdtsrf(klon)
   REAL globzplevnew
 
-  REAL vmrn2(ngridmx)
-  SAVE vmrn2
-  REAL stephan   
+  REAL vmrn2(klon)
+!   SAVE vmrn2
+  REAL stephan
   DATA stephan/5.67e-08/  ! Stephan Boltzman constant
   SAVE stephan
@@ -167,9 +168,9 @@
   IF (firstcall) THEN
      ccond=cpp/(g*lw_n2)
-     print*,'In condens_n2cloud: ccond=',ccond,' latcond=',lw_n2
+     print*,'In condense_n2cloud: ccond=',ccond,' latcond=',lw_n2
 
      ! calculate global mean surface pressure for the fast mode
      IF (fast) THEN
-        DO ig=1,ngridmx
+        DO ig=1,klon
            kp(ig) = exp(-phisfi(ig)/(r*38.))
         ENDDO
@@ -179,29 +180,29 @@
      vmrn2(:) = 1.
      IF (ch4lag) then
-        DO ig=1,ngridmx
-           if (lati(ig)*180./pi.ge.latlag) then
+        DO ig=1,klon
+           if (latitude(ig)*180./pi.ge.latlag) then
               vmrn2(ig) = vmrlag
            endif
         ENDDO
-     ENDIF   
+     ENDIF
      IF (no_n2frost) then
-        DO ig=1,ngridmx
+        DO ig=1,klon
            if (picen2(ig).eq.0.) then
               vmrn2(ig) = 1.e-15
            endif
         ENDDO
-     ENDIF   
+     ENDIF
      firstcall=.false.
   ENDIF
 
 !-----------------------------------------------------------------------
-!     Calculation of n2 condensation / sublimation 
+!     Calculation of n2 condensation / sublimation
 
 !     Variables used:
 !     picen2(klon)            : amount of n2 ice on the ground     (kg/m2)
-!     zcondicea(klon,nlayermx): condensation rate in layer l       (kg/m2/s)
+!     zcondicea(klon,klev): condensation rate in layer l       (kg/m2/s)
 !     zcondices(klon)         : condensation rate on the ground    (kg/m2/s)
-!     zfallice(klon,nlayermx) : amount of ice falling from layer l (kg/m2/s)
-!     zdtlatent(klon,nlayermx): dT/dt due to phase changes         (K/s)
+!     zfallice(klon,klev) : amount of ice falling from layer l (kg/m2/s)
+!     zdtlatent(klon,klev): dT/dt due to phase changes         (K/s)
 
 !     Tendencies initially set to 0
@@ -213,12 +214,12 @@
   pdicen2(1:klon) = 0.
   zfallheat=0
-  pdqc(1:klon,1:nlayer,1:nq)=0
-  pdtc(1:klon,1:nlayer)=0
-  pduc(1:klon,1:nlayer)=0
-  pdvc(1:klon,1:nlayer)=0
-  zfallice(1:klon,1:nlayer+1)=0
-  zcondicea(1:klon,1:nlayer)=0
-  zdtlatent(1:klon,1:nlayer)=0
-  zt(1:klon,1:nlayer)=0.
+  pdqc(1:klon,1:klev,1:nq)=0
+  pdtc(1:klon,1:klev)=0
+  pduc(1:klon,1:klev)=0
+  pdvc(1:klon,1:klev)=0
+  zfallice(1:klon,1:klev+1)=0
+  zcondicea(1:klon,1:klev)=0
+  zdtlatent(1:klon,1:klev)=0
+  zt(1:klon,1:klev)=0.
 
 !-----------------------------------------------------------------------
@@ -229,21 +230,21 @@
 !      (calcul of zcondicea , zfallice and pdtc)
 
-  zt(1:klon,1:nlayer)=pt(1:klon,1:nlayer)+ pdt(1:klon,1:nlayer)*ptimestep
+  zt(1:klon,1:klev)=pt(1:klon,1:klev)+ pdt(1:klon,1:klev)*ptimestep
   if (igcm_n2.ne.0) then
-     zqn2(1:klon,1:nlayer) = 1. ! & temporaire
-!        zqn2(1:klon,1:nlayer)= pq(1:klon,1:nlayer,igcm_n2) + pdq(1:klon,1:nlayer,igcm_n2)*ptimestep
+     zqn2(1:klon,1:klev) = 1. ! & temporaire
+!        zqn2(1:klon,1:klev)= pq(1:klon,1:klev,igcm_n2) + pdq(1:klon,1:klev,igcm_n2)*ptimestep
   else
-     zqn2(1:klon,1:nlayer) = 1.
+     zqn2(1:klon,1:klev) = 1.
   end if
-  
+
   if (.not.fast) then
 !     Forecast the atmospheric frost temperature 'ztcond' with function tcond_n2
-    DO l=1,nlayer
+    DO l=1,klev
       DO ig=1,klon
-          ztcond (ig,l) = tcond_n2(pplay(ig,l),zqn2(ig,l)) 
+          ztcond (ig,l) = tcond_n2(pplay(ig,l),zqn2(ig,l))
       ENDDO
     ENDDO
 
-    DO l=nlayer,1,-1
+    DO l=klev,1,-1
       DO ig=1,klon
        pdtc(ig,l)=0.  ! final tendancy temperature set to 0
@@ -251,6 +252,6 @@
        IF((zt(ig,l).LT.ztcond(ig,l)).or.(zfallice(ig,l+1).gt.0))THEN
            condsub(ig)=.true.  !condensation at level l
-           IF (zfallice(ig,l+1).gt.0) then 
-             zfallheat=zfallice(ig,l+1)*&  
+           IF (zfallice(ig,l+1).gt.0) then
+             zfallheat=zfallice(ig,l+1)*&
             (pphi(ig,l+1)-pphi(ig,l) +&
            cpice*(ztcond(ig,l+1)-ztcond(ig,l)))/lw_n2
@@ -266,5 +267,5 @@
                 .AND. (zfallice(ig,l+1).gt.0)) THEN
 
-              zdtlatent(ig,l)=(-zfallice(ig,l+1)+zfallheat)/&     
+              zdtlatent(ig,l)=(-zfallice(ig,l+1)+zfallheat)/&
                (ccond*(pplev(ig,l)-pplev(ig,l+1)))
               zcondicea(ig,l)= -zfallice(ig,l+1)
@@ -272,7 +273,7 @@
 
            zfallice(ig,l) = zcondicea(ig,l)+zfallice(ig,l+1)
-      
+
         END IF
-     
+
       ENDDO
     ENDDO
@@ -285,9 +286,9 @@
 !     Adding subtimesteps : in fast version, pressures too low lead to
 !     instabilities.
-  IF (fast) THEN 
+  IF (fast) THEN
      IF (pplev(1,1).gt.0.3) THEN
-         nsubtimestep= 1  
+         nsubtimestep= 1
      ELSE
-         nsubtimestep= nbsub !max(nint(ptimestep/dtmax),1) 
+         nsubtimestep= nbsub !max(nint(ptimestep/dtmax),1)
      ENDIF
   ELSE
@@ -307,5 +308,5 @@
        ENDDO
      ELSE
-     ! additional loop : 
+     ! additional loop :
      ! 1)  pressure updated
      ! 2)  direct redistribution of pressure over the globe
@@ -339,5 +340,5 @@
        ENDDO
      ENDIF  ! (itsub=1)
-   
+
    DO ig=1,klon
      ! forecast of frost temperature ztcondsol
@@ -353,5 +354,5 @@
 !     Condensation or partial sublimation of N2 ice
         if (ztsrf(ig) .LT. ztcondsol(ig)) then  ! condensation
-!             Include a correction to account for the cooling of air near 
+!             Include a correction to account for the cooling of air near
 !             the surface before condensing:
          zcondices(ig)=pcapcal(ig)*(ztcondsol(ig)-ztsrf(ig)) &
@@ -359,5 +360,5 @@
         else                                    ! sublimation
           zcondices(ig)=pcapcal(ig)*(ztcondsol(ig)-ztsrf(ig)) &
-          /(lw_n2*subtimestep) 
+          /(lw_n2*subtimestep)
         end if
 
@@ -369,5 +370,5 @@
         IF((zpicen2(ig)/subtimestep).LE. &
             -zcondices(ig))THEN
-           zcondices(ig) = -zpicen2(ig)/subtimestep 
+           zcondices(ig) = -zpicen2(ig)/subtimestep
            pdtsrfc(ig)=(lw_n2/pcapcal(ig))*       &
                (zcondices(ig))
@@ -376,5 +377,5 @@
 !     Changing N2 ice amount and pressure
 
-        pdicen2(ig) = zcondices(ig) 
+        pdicen2(ig) = zcondices(ig)
         pdpsrf(ig)   = -pdicen2(ig)*g
     !    pdpsrf(ig)   = 0. ! OPTION to check impact N2 sub/cond
@@ -411,5 +412,5 @@
      if(.not.picen2(ig).ge.0.) THEN
 !           if(picen2(ig) + pdicen2(ig)*ptimestep.le.-1.e-8) then
-          print*, 'WARNING NEG RESERVOIR in condense_n2: picen2(',ig,')=', picen2(ig) + pdicen2(ig)*ptimestep  
+          print*, 'WARNING NEG RESERVOIR in condense_n2: picen2(',ig,')=', picen2(ig) + pdicen2(ig)*ptimestep
 !              pdicen2(ig)= -picen2(ig)/ptimestep
 !           else
@@ -420,5 +421,5 @@
 
 ! ***************************************************************
-!  Correction to account for redistribution between sigma or hybrid 
+!  Correction to account for redistribution between sigma or hybrid
 !  layers when changing surface pressure (and warming/cooling
 !  of the n2 currently changing phase).
@@ -431,14 +432,14 @@
 !  """"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
         zmflux(1) = -zcondices(ig)
-        DO l=1,nlayer
+        DO l=1,klev
          zmflux(l+1) = zmflux(l) -zcondicea(ig,l)  &
-         + (bp(l)-bp(l+1))*(zfallice(ig,1)-zmflux(1))     
-! zmflux set to 0 if very low to avoid: top layer is disappearing in v1ld  
+         + (bp(l)-bp(l+1))*(zfallice(ig,1)-zmflux(1))
+! zmflux set to 0 if very low to avoid: top layer is disappearing in v1ld
       if (abs(zmflux(l+1)).lt.1E-13.OR.bp(l+1).eq.0.) zmflux(l+1)=0.
         END DO
 
 ! Mass of each layer
-! ------------------ 
-       DO l=1,nlayer
+! ------------------
+       DO l=1,klev
          masse(l)=(pplev(ig,l) - pplev(ig,l+1))/g
        END DO
@@ -447,28 +448,28 @@
 !  Corresponding fluxes for T,U,V,Q
 !  """"""""""""""""""""""""""""""""
-!           averaging operator for TRANSPORT  
+!           averaging operator for TRANSPORT
 !           """"""""""""""""""""""""""""""""
 
 !           Subtimestep loop to perform the redistribution gently and simultaneously with
-!           the other tendencies  
+!           the other tendencies
 !           Estimation of subtimestep (using only  the first layer, the most critical)
         dtmax=ptimestep
-        if (zmflux(1).gt.1.e-20) then 
+        if (zmflux(1).gt.1.e-20) then
             dtmax=min(dtmax,masse(1)*zqn2(ig,1)/abs(zmflux(1)))
         endif
-        nsubtimestep= max(nint(ptimestep/dtmax),nint(2.)) 
+        nsubtimestep= max(nint(ptimestep/dtmax),nint(2.))
         subtimestep=ptimestep/float(nsubtimestep)
 
 !          New flux for each subtimestep
-       do l=1,nlayer+1
+       do l=1,klev+1
             w(l)=-zmflux(l)*subtimestep
        enddo
 !          initializing variables that will vary during subtimestep:
-       do l=1,nlayer
-           ztc(l)  =pt(ig,l)   
-           zu(l)   =pu(ig,l) 
-           zv(l)   =pv(ig,l)  
-           do iq=1,nqmx
-              zq(l,iq) = pq(ig,l,iq) 
+       do l=1,klev
+           ztc(l)  =pt(ig,l)
+           zu(l)   =pu(ig,l)
+           zv(l)   =pv(ig,l)
+           do iq=1,nq
+              zq(l,iq) = pq(ig,l,iq)
            enddo
        end do
@@ -477,10 +478,10 @@
 !          """"""""""""""""""""""
        do itsub=1,nsubtimestep
-!             Progressively adding tendancies from other processes. 
-          do l=1,nlayer
+!             Progressively adding tendancies from other processes.
+          do l=1,klev
              ztc(l)  =ztc(l)   +(pdt(ig,l) + zdtlatent(ig,l))*subtimestep
              zu(l)   =zu(l)   +pdu( ig,l) * subtimestep
              zv(l)   =zv(l)   +pdv( ig,l) * subtimestep
-             do iq=1,nqmx
+             do iq=1,nq
                 zq(l,iq) = zq(l,iq) + pdq(ig,l,iq)* subtimestep
              enddo
@@ -488,25 +489,25 @@
 
 !             Change of mass in each layer
-          do l=1,nlayer
+          do l=1,klev
              masse(l)=masse(l)+pdpsrf(ig)*subtimestep*(pplev(ig,l) - pplev(ig,l+1))&
                                              /(g*pplev(ig,1))
           end do
 
-           ztm(2:nlayermx+1)=0.
-           zum(2:nlayermx+1)=0.
-           zvm(2:nlayermx+1)=0.
-           zqm1(1:nlayermx+1)=0.
+           ztm(2:klev+1)=0.
+           zum(2:klev+1)=0.
+           zvm(2:klev+1)=0.
+           zqm1(1:klev+1)=0.
 
 !             Van Leer scheme:
-          call vl1d(nlayer,ztc,2.,masse,w,ztm) 
-          call vl1d(nlayer,zu ,2.,masse,w,zum) 
-          call vl1d(nlayer,zv ,2.,masse,w,zvm) 
-         do iq=1,nqmx
-           do l=1,nlayer
+          call vl1d(klev,ztc,2.,masse,w,ztm)
+          call vl1d(klev,zu ,2.,masse,w,zum)
+          call vl1d(klev,zv ,2.,masse,w,zvm)
+         do iq=1,nq
+           do l=1,klev
             zq1(l)=zq(l,iq)
            enddo
            zqm1(1)=zqm(1,iq)
-           call vl1d(nlayer,zq1,2.,masse,w,zqm1)
-           do l=2,nlayer
+           call vl1d(klev,zq1,2.,masse,w,zqm1)
+           do l=2,klev
             zqm(l,iq)=zqm1(l)
            enddo
@@ -516,9 +517,9 @@
           if (igcm_n2.ne.0) then
             zqm(1,igcm_n2)=1.
-            do l=1,nlayer-1
-              if (w(l)*zqm(l,igcm_n2).gt.zq(l,igcm_n2)*masse(l)) then 
+            do l=1,klev-1
+              if (w(l)*zqm(l,igcm_n2).gt.zq(l,igcm_n2)*masse(l)) then
                  zqm(l+1,igcm_n2)=max(zqm(l+1,igcm_n2),    &
                  (zqm(l,igcm_n2)*w(l) -zq(l,igcm_n2)*masse(l))/w(l+1) )
-              else 
+              else
                 exit
               endif
@@ -528,16 +529,16 @@
 !             Value transfert at the surface interface when condensation sublimation:
 
-          if (zmflux(1).lt.0) then 
+          if (zmflux(1).lt.0) then
 !               Surface condensation
             zum(1)= zu(1)
-            zvm(1)= zv(1) 
+            zvm(1)= zv(1)
             ztm(1) = ztc(1)
-          else 
+          else
 !               Surface sublimation:
             ztm(1) = ztsrf(ig) + pdtsrfc(ig)*ptimestep
-            zum(1) = 0  
-            zvm(1) = 0  
+            zum(1) = 0
+            zvm(1) = 0
           end if
-          do iq=1,nqmx
+          do iq=1,nq
              zqm(1,iq)=0. ! most tracer do not condense !
           enddo
@@ -550,5 +551,5 @@
             DO iq=1,nq
              tname=noms(iq)
-             if (tname(1:4).eq."haze") then 
+             if (tname(1:4).eq."haze") then
                    !zqm(1,iq)=0.02
                    !zqm(1,iq)=-pdicen2(ig)*0.02
@@ -559,16 +560,16 @@
              endif
             ENDDO
-           ENDIF      
-          ENDIF      
-          ztm(nlayer+1)= ztc(nlayer) ! should not be used, but... 
-          zum(nlayer+1)= zu(nlayer)  ! should not be used, but...
-          zvm(nlayer+1)= zv(nlayer)  ! should not be used, but...
-          do iq=1,nqmx
-           zqm(nlayer+1,iq)= zq(nlayer,iq)
+           ENDIF
+          ENDIF
+          ztm(klev+1)= ztc(klev) ! should not be used, but...
+          zum(klev+1)= zu(klev)  ! should not be used, but...
+          zvm(klev+1)= zv(klev)  ! should not be used, but...
+          do iq=1,nq
+           zqm(klev+1,iq)= zq(klev,iq)
           enddo
 
-!             Tendencies on T, U, V, Q 
+!             Tendencies on T, U, V, Q
 !             """""""""""""""""""""""
-          DO l=1,nlayer
+          DO l=1,klev
 
 !               Tendencies on T
@@ -591,8 +592,8 @@
 
 !             Tendencies on Q
-          do iq=1,nqmx
+          do iq=1,nq
             if (iq.eq.igcm_n2) then
 !                 SPECIAL Case when the tracer IS N2 :
-              DO l=1,nlayer
+              DO l=1,klev
               pdqc(ig,l,iq)= (1/masse(l)) *        &
                ( zmflux(l)*(zqm(l,iq) - zq(l,iq))    &
@@ -601,5 +602,5 @@
               END DO
             else
-              DO l=1,nlayer
+              DO l=1,klev
                 pdqc(ig,l,iq)= (1/masse(l)) *         &
                ( zmflux(l)*(zqm(l,iq) - zq(l,iq))     &
@@ -610,9 +611,9 @@
           enddo
 !             Update variables at the end of each subtimestep.
-          do l=1,nlayer
+          do l=1,klev
             ztc(l)  =ztc(l)  + zdtsig(ig,l)  *subtimestep
             zu(l)   =zu(l)   + pduc(ig,l)  *subtimestep
             zv(l)   =zv(l)   + pdvc(ig,l)  *subtimestep
-            do iq=1,nqmx
+            do iq=1,nq
               zq(l,iq) = zq(l,iq) + pdqc(ig,l,iq)*subtimestep
             enddo
@@ -620,9 +621,9 @@
        enddo   ! loop on nsubtimestep
 !          Recomputing Total tendencies
-       do l=1,nlayer
+       do l=1,klev
          pdtc(ig,l)   = (ztc(l) - zt(ig,l) )/ptimestep
          pduc(ig,l)   = (zu(l) - (pu(ig,l) + pdu(ig,l)*ptimestep))/ptimestep
          pdvc(ig,l)   = (zv(l) - (pv(ig,l) + pdv(ig,l)*ptimestep))/ptimestep
-         do iq=1,nqmx
+         do iq=1,nq
            pdqc(ig,l,iq) = (zq(l,iq) - (pq(ig,l,iq) + pdq(ig,l,iq)*ptimestep))/ptimestep
 
@@ -632,5 +633,5 @@
              if((pq(ig,l,iq) +(pdqc(ig,l,iq)+ pdq(ig,l,iq))*ptimestep) &
                      .lt.0.01) then ! if n2 < 1 %  !
-               pdqc(ig,l,iq)=(0.01-pq(ig,l,iq))/ptimestep-pdq(ig,l,iq)  
+               pdqc(ig,l,iq)=(0.01-pq(ig,l,iq))/ptimestep-pdq(ig,l,iq)
              end if
             end if
@@ -639,8 +640,8 @@
        end do
 ! *******************************TEMPORAIRE ******************
-       if (klon.eq.1) then 
+       if (klon.eq.1) then
               write(*,*) 'nsubtimestep=' ,nsubtimestep
            write(*,*) 'masse avant' , (pplev(ig,1) - pplev(ig,2))/g
-              write(*,*) 'masse apres' , masse(1) 
+              write(*,*) 'masse apres' , masse(1)
               write(*,*) 'zmflux*DT, l=1' ,  zmflux(1)*ptimestep
               write(*,*) 'zmflux*DT, l=2' ,  zmflux(2)*ptimestep
@@ -653,5 +654,5 @@
 ! ***********************************************************
     end if ! if (condsub)
-   END DO  ! loop on ig 
+   END DO  ! loop on ig
   endif ! not fast
 
@@ -660,13 +661,13 @@
   if (olkin) then
   DO ig=1,klon
-     if (lati(ig).lt.0) then
+     if (latitude(ig).lt.0) then
        pdtsrfc(ig) = max(0.,pdtsrfc(ig))
        pdpsrf(ig) = 0.
        pdicen2(ig)  = 0.
-       do l=1,nlayer
+       do l=1,klev
          pdtc(ig,l)  =  max(0.,zdtlatent(ig,l))
          pduc(ig,l)  = 0.
          pdvc(ig,l)  = 0.
-         do iq=1,nqmx
+         do iq=1,nq
            pdqc(ig,l,iq) = 0
          enddo
@@ -681,5 +682,5 @@
 ! ***************************************************************
 
-!     DO l=1,nlayer
+!     DO l=1,klev
 !        DO ig=1,klon
 !         Taux de cond en kg.m-2.pa-1.s-1
@@ -689,8 +690,8 @@
 !        END DO
 !     END DO
-!     call WRITEDIAGFI(ngridmx,'tconda1',              &
+!     call WRITEDIAGFI(klon,'tconda1',              &
 !     'Taux de condensation N2 atmospherique /Pa',    &
 !      'kg.m-2.Pa-1.s-1',3,tconda1)
-!     call WRITEDIAGFI(ngridmx,'tconda2',              &
+!     call WRITEDIAGFI(klon,'tconda2',              &
 !     'Taux de condensation N2 atmospherique /m',     &
 !      'kg.m-3.s-1',3,tconda2)
@@ -698,5 +699,5 @@
 
   return
-  end subroutine condens_n2
+  end subroutine condense_n2
 
 !-------------------------------------------------------------------------
@@ -729,5 +730,5 @@
 !       tcond_n2 = (1.)/(0.026315-0.0011877*log(.7143*p*vmr))
   IF (t.ge.35.6) then
-!     tcond Fray and Schmitt for N2 phase beta (T>35.6 K) FIT TB 
+!     tcond Fray and Schmitt for N2 phase beta (T>35.6 K) FIT TB
   ! pcond_n2 = 0.125570*1.e5/vmr*exp((2.5e5*0.98)/296.925*(1./63.1470-1./t))
     pcond_n2 = 0.125570e5/vmr*exp(825.1241896*(1./63.147-1./t))
@@ -743,19 +744,23 @@
 
   real function glob_average2d(var)
-!   Calculates the global average of variable var     
+!   Calculates the global average of variable var
   use comgeomfi_h
+  use dimphy, only: klon
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+  use geometry_mod, only: cell_area, latitude
+
   implicit none
 
 !      INTEGER klon
-  REAL var(ngridmx)
+  REAL var(klon)
   INTEGER ig
 
   glob_average2d = 0.
-  DO ig=2,ngridmx-1
-       glob_average2d = glob_average2d + var(ig)*area(ig)
+  DO ig=2,klon-1
+       glob_average2d = glob_average2d + var(ig)*cell_area(ig)
   END DO
-  glob_average2d = glob_average2d + var(1)*area(1)*iim
-  glob_average2d = glob_average2d + var(ngridmx)*area(ngridmx)*iim
-  glob_average2d = glob_average2d/(totarea+(area(1)+area(ngridmx))*(iim-1))
+  glob_average2d = glob_average2d + var(1)*cell_area(1)*nbp_lon
+  glob_average2d = glob_average2d + var(klon)*cell_area(klon)*nbp_lon
+  glob_average2d = glob_average2d/(totarea+(cell_area(1)+cell_area(klon))*(nbp_lon-1))
 
   end function glob_average2d
@@ -763,6 +768,6 @@
 ! *****************************************************************
 
-  subroutine vl1d(nlayer,q,pente_max,masse,w,qm)
-!    
+  subroutine vl1d(klev,q,pente_max,masse,w,qm)
+!
 !     Operateur de moyenne inter-couche pour calcul de transport type
 !     Van-Leer " pseudo amont " dans la verticale
@@ -776,28 +781,28 @@
 !   Arguments:
 !   ----------
-  integer nlayer
-  real masse(nlayer),pente_max
-  REAL q(nlayer),qm(nlayer+1)
-  REAL w(nlayer+1)
-!
-!      Local 
+  integer klev
+  real masse(klev),pente_max
+  REAL q(klev),qm(klev+1)
+  REAL w(klev+1)
+!
+!      Local
 !   ---------
 !
   INTEGER l
 !
-  real dzq(nlayer),dzqw(nlayer),adzqw(nlayer),dzqmax
+  real dzq(klev),dzqw(klev),adzqw(klev),dzqmax
   real sigw, Mtot, MQtot
-  integer m 
-
-
-!    On oriente tout dans le sens de la pression 
+  integer m
+
+
+!    On oriente tout dans le sens de la pression
 !     W > 0 WHEN DOWN !!!!!!!!!!!!!
 
-  do l=2,nlayer
+  do l=2,klev
         dzqw(l)=q(l-1)-q(l)
         adzqw(l)=abs(dzqw(l))
   enddo
 
-  do l=2,nlayer-1
+  do l=2,klev-1
         if(dzqw(l)*dzqw(l+1).gt.0.) then
             dzq(l)=0.5*(dzqw(l)+dzqw(l+1))
@@ -810,7 +815,7 @@
 
      dzq(1)=0.
-     dzq(nlayer)=0.
-
-   do l = 1,nlayer-1
+     dzq(klev)=0.
+
+   do l = 1,klev-1
 
 !         Regular scheme (transfered mass < layer mass)
@@ -829,14 +834,14 @@
          Mtot = masse(m)
          MQtot = masse(m)*q(m)
-         !if (m.lt.nlayer) then ! because some compilers will have problems
-         !                      ! evaluating masse(nlayer+1)
-         do while ((m.lt.nlayer).and.(w(l+1).gt.(Mtot+masse(m+1))))
+         !if (m.lt.klev) then ! because some compilers will have problems
+         !                      ! evaluating masse(klev+1)
+         do while ((m.lt.klev).and.(w(l+1).gt.(Mtot+masse(m+1))))
             m=m+1
             Mtot = Mtot + masse(m)
             MQtot = MQtot + masse(m)*q(m)
-         !   if (m.eq.nlayer) exit
+         !   if (m.eq.klev) exit
          end do
          !endif
-         if (m.lt.nlayer) then
+         if (m.lt.klev) then
             sigw=(w(l+1)-Mtot)/masse(m+1)
             qm(l+1)= (1/w(l+1))*(MQtot + (w(l+1)-Mtot)* &
@@ -848,6 +853,6 @@
             stop
          end if
-      else      ! if(w(l+1).lt.0) 
-         m = l-1 
+      else      ! if(w(l+1).lt.0)
+         m = l-1
          Mtot = masse(m+1)
          MQtot = masse(m+1)*q(m+1)
@@ -863,9 +868,9 @@
          if (m.gt.0) then
             sigw=(w(l+1)+Mtot)/masse(m)
-            qm(l+1)= (-1/w(l+1))*(MQtot + (-w(l+1)-Mtot)* & 
+            qm(l+1)= (-1/w(l+1))*(MQtot + (-w(l+1)-Mtot)* &
            (q(m)-0.5*(1.+sigw)*dzq(m))  )
          else
             qm(l+1)= (-1/w(l+1))*(MQtot + (-w(l+1)-Mtot)*qm(1))
-         end if   
+         end if
       end if
    enddo
